Index: ivorbisfile_example.c
===================================================================
--- ivorbisfile_example.c	(revision 16592)
+++ ivorbisfile_example.c	(working copy)
@@ -29,7 +29,7 @@
 #include <fcntl.h>
 #endif
 
-char pcmout[4096]; /* take 4k out of the data segment, not the stack */
+short pcmout[2048]; /* take 4k out of the data segment, not the stack */
 
 int main(){
   OggVorbis_File vf;
@@ -64,13 +64,18 @@
   }
   
   while(!eof){
-    long ret=ov_read(&vf,pcmout,sizeof(pcmout),&current_section);
+    long ret=ov_read(&vf,(char*)pcmout,sizeof(pcmout),&current_section);
     if (ret == 0) {
       /* EOF */
       eof=1;
+    } else if (ret == OV_EINVAL) {
+      /* something about this call was seriously wrong */
+      fprintf(stderr, "Invalid data was passed to ov_read somehow\n");
+      return(1);
     } else if (ret < 0) {
-      /* error in the stream.  Not a problem, just reporting it in
-	 case we (the app) cares.  In this case, we don't. */
+      /* some other error in the stream.  Not a problem, just
+	 reporting it in case we (the app) cares.  In this case, we
+	 don't. */
     } else {
       /* we don't bother dealing with sample rate changes, etc, but
 	 you'll have to*/
